﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using HeuristicLab.Hive.Contracts.Interfaces;
using System.ServiceModel;
using HeuristicLab.Hive.Contracts;
using HeuristicLab.Hive.Experiment.Properties;

namespace HeuristicLab.Hive.Experiment {
  internal class ServiceLocator {
    internal static IClientFacade CreateClientFacade(string hostAddress) {
      ChannelFactory<IClientFacade> factory = new ChannelFactory<IClientFacade>("ClientHttpEndpoint");
      WcfSettings.SetEndpointAddress(factory.Endpoint, hostAddress);

      factory.Credentials.UserName.UserName = Settings.Default.HiveUsername;
      factory.Credentials.UserName.Password = Settings.Default.HivePassword;

      IClientFacade client = factory.CreateChannel();
      return client;
    }

    internal static IClientFacade CreateStreamedClientFacade(string hostAddress) {
      ChannelFactory<IClientFacade> factory = new ChannelFactory<IClientFacade>("ClientTcpStreamedEndpoint");
      WcfSettings.SetEndpointAddress(factory.Endpoint, hostAddress);

      factory.Credentials.UserName.UserName = Settings.Default.HiveUsername;
      factory.Credentials.UserName.Password = Settings.Default.HivePassword;

      IClientFacade client = factory.CreateChannel();
      return client;
    }

    public static void DisposeClientFacade(IClientFacade clientFacade) {
      WcfSettings.DisposeWcfClient((ICommunicationObject)clientFacade);      
    }
  }
}
